{* This file contains:
 *
 * 1.  The traditional identifiers for gadget Flags, Activation, and Type,
 * and for window Flags and IDCMP classes.  They are defined in terms
 * of their new versions, which serve to prevent confusion between
 * similar-sounding but different identifiers (like IDCMP_WINDOWACTIVE
 * and WFLG_ACTIVATE).
 *
 * 2.  Some tag names and constants whose labels were adjusted after V36.
 *
 * By default, 1 and 2 are enabled.
 *
 * #define INTUI_V36_NAMES_ONLY to exclude the traditional identifiers and
 * the original V36 names of some identifiers.
 *
 *}


CONST
{ V34-style Gadget->Flags names: }

 GADGHIGHBITS  =  GFLG_GADGHIGHBITS;
 GADGHCOMP     =  GFLG_GADGHCOMP   ;
 GADGHBOX      =  GFLG_GADGHBOX    ;
 GADGHIMAGE    =  GFLG_GADGHIMAGE  ;
 GADGHNONE     =  GFLG_GADGHNONE   ;
 GADGIMAGE     =  GFLG_GADGIMAGE   ;
 GRELBOTTOM    =  GFLG_RELBOTTOM   ;
 GRELRIGHT     =  GFLG_RELRIGHT    ;
 GRELWIDTH     =  GFLG_RELWIDTH    ;
 GRELHEIGHT    =  GFLG_RELHEIGHT   ;
 SELECTED      =  GFLG_SELECTED    ;
 GADGDISABLED  =  GFLG_DISABLED    ;
 LABELMASK     =  GFLG_LABELMASK   ;
 LABELITEXT    =  GFLG_LABELITEXT  ;
 LABELSTRING   =  GFLG_LABELSTRING ;
 LABELIMAGE    =  GFLG_LABELIMAGE  ;


{ V34-style Gadget->Activation flag names: }

 RELVERIFY     =  GACT_RELVERIFY   ;
 GADGIMMEDIATE =  GACT_IMMEDIATE   ;
 ENDGADGET     =  GACT_ENDGADGET   ;
 FOLLOWMOUSE   =  GACT_FOLLOWMOUSE ;
 RIGHTBORDER   =  GACT_RIGHTBORDER ;
 LEFTBORDER    =  GACT_LEFTBORDER  ;
 TOPBORDER     =  GACT_TOPBORDER   ;
 BOTTOMBORDER  =  GACT_BOTTOMBORDER;
 BORDERSNIFF   =  GACT_BORDERSNIFF ;
 TOGGLESELECT  =  GACT_TOGGLESELECT;
 BOOLEXTEND    =  GACT_BOOLEXTEND  ;
 STRINGLEFT    =  GACT_STRINGLEFT  ;
 STRINGCENTER  =  GACT_STRINGCENTER;
 STRINGRIGHT   =  GACT_STRINGRIGHT ;
 LONGINT       =  GACT_LONGINT     ;
 ALTKEYMAP     =  GACT_ALTKEYMAP   ;
 STRINGEXTEND_f=  GACT_STRINGEXTEND;
 ACTIVEGADGET  =  GACT_ACTIVEGADGET;


{ V34-style Gadget->Type names: }

 GADGETTYPE    =  GTYP_GADGETTYPE  ;
 SYSGADGET     =  GTYP_SYSGADGET   ;
 SCRGADGET     =  GTYP_SCRGADGET   ;
 GZZGADGET     =  GTYP_GZZGADGET   ;
 REQGADGET     =  GTYP_REQGADGET   ;
 SIZING        =  GTYP_SIZING      ;
 WDRAGGING     =  GTYP_WDRAGGING   ;
 SDRAGGING     =  GTYP_SDRAGGING   ;
 WUPFRONT      =  GTYP_WUPFRONT    ;
 SUPFRONT      =  GTYP_SUPFRONT    ;
 WDOWNBACK     =  GTYP_WDOWNBACK   ;
 SDOWNBACK     =  GTYP_SDOWNBACK   ;
 CLOSE         =  GTYP_CLOSE       ;
 BOOLGADGET    =  GTYP_BOOLGADGET  ;
 GADGET0002    =  GTYP_GADGET0002  ;
 PROPGADGET    =  GTYP_PROPGADGET  ;
 STRGADGET     =  GTYP_STRGADGET   ;
 CUSTOMGADGET  =  GTYP_CUSTOMGADGET;
 GTYPEMASK     =  GTYP_GTYPEMASK   ;


{ V34-style IDCMP class names: }

 SIZEVERIFY_f    =  IDCMP_SIZEVERIFY    ;
 NEWSIZE_f       =  IDCMP_NEWSIZE       ;
 REFRESHWINDOW_f =  IDCMP_REFRESHWINDOW ;
 MOUSEBUTTONS_f  =  IDCMP_MOUSEBUTTONS  ;
 MOUSEMOVE_f     =  IDCMP_MOUSEMOVE     ;
 GADGETDOWN_f    =  IDCMP_GADGETDOWN    ;
 GADGETUP_f      =  IDCMP_GADGETUP      ;
 REQSET_f        =  IDCMP_REQSET        ;
 MENUPICK_f      =  IDCMP_MENUPICK      ;
 CLOSEWINDOW_f   =  IDCMP_CLOSEWINDOW   ;
 RAWKEY_f        =  IDCMP_RAWKEY        ;
 REQVERIFY_f     =  IDCMP_REQVERIFY     ;
 REQCLEAR_f      =  IDCMP_REQCLEAR      ;
 MENUVERIFY_f    =  IDCMP_MENUVERIFY    ;
 NEWPREFS_f      =  IDCMP_NEWPREFS      ;
 DISKINSERTED_f  =  IDCMP_DISKINSERTED  ;
 DISKREMOVED_f   =  IDCMP_DISKREMOVED   ;
 WBENCHMESSAGE_f =  IDCMP_WBENCHMESSAGE ;
 ACTIVEWINDOW_f  =  IDCMP_ACTIVEWINDOW  ;
 INACTIVEWINDOW_f=  IDCMP_INACTIVEWINDOW;
 DELTAMOVE_f     =  IDCMP_DELTAMOVE     ;
 VANILLAKEY_f    =  IDCMP_VANILLAKEY    ;
 INTUITICKS_f    =  IDCMP_INTUITICKS    ;
 IDCMPUPDATE_f   =  IDCMP_IDCMPUPDATE   ;
 MENUHELP_f      =  IDCMP_MENUHELP      ;
 CHANGEWINDOW_f  =  IDCMP_CHANGEWINDOW  ;
 LONELYMESSAGE_f =  IDCMP_LONELYMESSAGE ;


{ V34-style Window->Flags names: }

 WINDOWSIZING   = WFLG_SIZEGADGET    ;
 WINDOWDRAG     = WFLG_DRAGBAR       ;
 WINDOWDEPTH    = WFLG_DEPTHGADGET   ;
 WINDOWCLOSE    = WFLG_CLOSEGADGET   ;
 SIZEBRIGHT     = WFLG_SIZEBRIGHT    ;
 SIZEBBOTTOM    = WFLG_SIZEBBOTTOM   ;
 REFRESHBITS    = WFLG_REFRESHBITS   ;
 SMART_REFRESH  = WFLG_SMART_REFRESH ;
 SIMPLE_REFRESH = WFLG_SIMPLE_REFRESH;
 SUPER_BITMAP   = WFLG_SUPER_BITMAP  ;
 OTHER_REFRESH  = WFLG_OTHER_REFRESH ;
 BACKDROP       = WFLG_BACKDROP      ;
 REPORTMOUSE_f  = WFLG_REPORTMOUSE   ;
 GIMMEZEROZERO  = WFLG_GIMMEZEROZERO ;
 BORDERLESS     = WFLG_BORDERLESS    ;
 ACTIVATE       = WFLG_ACTIVATE      ;
 WINDOWACTIVE   = WFLG_WINDOWACTIVE  ;
 INREQUEST      = WFLG_INREQUEST     ;
 MENUSTATE      = WFLG_MENUSTATE     ;
 RMBTRAP        = WFLG_RMBTRAP       ;
 NOCAREREFRESH  = WFLG_NOCAREREFRESH ;
 WINDOWREFRESH  = WFLG_WINDOWREFRESH ;
 WBENCHWINDOW   = WFLG_WBENCHWINDOW  ;
 WINDOWTICKED   = WFLG_WINDOWTICKED  ;
 NW_EXTENDED    = WFLG_NW_EXTENDED   ;
 VISITOR        = WFLG_VISITOR       ;
 ZOOMED         = WFLG_ZOOMED        ;
 HASZOOM        = WFLG_HASZOOM       ;



